#!/usr/bin/perl
###############################################################################

use File::Find;

@ARGV = qw(.) unless @ARGV;

$num_files = 0;
$num_dirs = 0;
$num_links = 0;
$num_revisions = 0;

sub count_revisions
{
	$file = $_;

	if (-d $file) { $num_dirs++; return; }
	if ($file =~ /\.lnk\.sh,v$/) { $num_links++; $num_files++; return; }
	return if ($file !~ /,v$/);
	$num_files++;

	print STDERR "processing file $num_files : \"$file\" ... \n";

	open (RLOG, "rlog -h '$file'|") || die;

	while (<RLOG>)
	{
		if (/^total revisions:\s(\d+)$/) { $num_revisions += $1; }
	}

	close (RLOG);
}

find (\&count_revisions, @ARGV);

print STDERR "=============================================================\n";

print "num_files      $num_files\n";
print "num_dirs       $num_dirs\n";
print "num_links      $num_links\n";
print "num_revisions  $num_revisions\n";
